#tag Module
Protected Module ReportExtension
	#tag Method, Flags = &h0
		Sub AddFooter(extends r as report, footer as Reports.RBReportSection)
		  Static _AddFooter As Xojo.Introspection.MethodInfo
		  If _AddFooter = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "AddFooter" Then
		        _AddFooter = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append footer
		  _AddFooter.Invoke(r, a)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub AddGroup(extends r as report, group as Reports.RBReportGroup)
		  Static _AddGroup As Xojo.Introspection.MethodInfo
		  If _AddGroup = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "AddGroup" Then
		        _AddGroup = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append group
		  _AddGroup.Invoke(r, a)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub AddHeader(extends r as report, header as Reports.RBReportSection)
		  Static _AddHeader As Xojo.Introspection.MethodInfo
		  If _AddHeader = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "AddHeader" Then
		        _AddHeader = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append header
		  _AddHeader.Invoke(r, a)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub AddItemToCurrentPage(extends r as report)
		  Static _AddItemToCurrentPage As Xojo.Introspection.MethodInfo
		  If _AddItemToCurrentPage = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "AddItemToCurrentPage" Then
		        _AddItemToCurrentPage = method
		        Exit For
		      End If
		    Next
		  End If
		  _AddItemToCurrentPage.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub AddToPage(extends r as report, page as int64)
		  Static _AddToPage As Xojo.Introspection.MethodInfo
		  If _AddToPage = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "AddToPage" Then
		        _AddToPage = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append page
		  _AddToPage.Invoke(r, a)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Close(extends r as report)
		  Static _Close As Xojo.Introspection.MethodInfo
		  If _Close = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "Close" Then
		        _Close = method
		        Exit For
		      End If
		    Next
		  End If
		  _Close.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function CurrentPage(extends r as report) As Graphics
		  Static _CurrentPage As Xojo.Introspection.MethodInfo
		  If _CurrentPage = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "CurrentPage" Then
		        _CurrentPage = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _CurrentPage.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function CurrentPageNumber(extends r as report) As Int64
		  Static _CurrentPageNumber As Xojo.Introspection.MethodInfo
		  If _CurrentPageNumber = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "CurrentPageNumber" Then
		        _CurrentPageNumber = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _CurrentPageNumber.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function CurrentPosition(extends r as report) As Int64
		  Static _CurrentPosition As Xojo.Introspection.MethodInfo
		  If _CurrentPosition = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "CurrentPosition" Then
		        _CurrentPosition = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _CurrentPosition.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function DataSource(extends r as report) As Reports.Dataset
		  Static _DataSource As Xojo.Introspection.PropertyInfo
		  If _DataSource = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "DataSource" Then
		        _DataSource = prop
		        Exit For
		      End If
		    Next
		  End If
		  Return _DataSource.Value(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub DataSource(extends r as report, assigns value as Reports.Dataset)
		  Static _setDataSource As Xojo.Introspection.PropertyInfo
		  If _setDataSource = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "DataSource" Then
		        _setDataSource = prop
		        Exit For
		      End If
		    Next
		  End If
		  _setDataSource.Value(r) = value
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function DPI(extends r as report) As Int64
		  Static _dpi As Xojo.Introspection.MethodInfo
		  If _dpi = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "DPI" Then
		        _dpi = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _dpi.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub EndReport(extends r as report)
		  Static _EndReport As Xojo.Introspection.MethodInfo
		  If _EndReport = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "EndReport" Then
		        _EndReport = method
		        Exit For
		      End If
		    Next
		  End If
		  _EndReport.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function FontScale(extends r as report) As Double
		  Static _FontScale As Xojo.Introspection.MethodInfo
		  If _FontScale = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "FontScale" Then
		        _FontScale = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _FontScale.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Footer(extends r as report) As Reports.RBReportSection
		  Static _Footer As Xojo.Introspection.PropertyInfo
		  If _Footer = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "Footer" Then
		        _Footer = prop
		        Exit For
		      End If
		    Next
		  End If
		  Return _Footer.Value(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Footer(extends r as report, assigns value as Reports.RBReportSection)
		  Static _setFooter As Xojo.Introspection.PropertyInfo
		  If _setFooter = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "Footer" Then
		        _setFooter = prop
		        Exit For
		      End If
		    Next
		  End If
		  _setFooter.Value(r) = value
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Group(extends r as report) As Reports.RBReportGroup
		  Static _Group As Xojo.Introspection.PropertyInfo
		  If _Group = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "Group" Then
		        _Group = prop
		        Exit For
		      End If
		    Next
		  End If
		  Return _Group.Value(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Group(extends r as report, assigns value as Reports.RBReportGroup)
		  Static _setGroup As Xojo.Introspection.PropertyInfo
		  If _setGroup = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "Group" Then
		        _setGroup = prop
		        Exit For
		      End If
		    Next
		  End If
		  _setGroup.Value(r) = value
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Header(extends r as report) As Reports.RBReportSection
		  Static _Header As Xojo.Introspection.PropertyInfo
		  If _Header = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "Header" Then
		        _Header = prop
		        Exit For
		      End If
		    Next
		  End If
		  Return _Header.Value(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Header(extends r as report, assigns value as Reports.RBReportSection)
		  Static _setHeader As Xojo.Introspection.PropertyInfo
		  If _setHeader = Nil Then 
		    Dim props() As Xojo.Introspection.PropertyInfo = r.properties
		    For q As Integer = 0 To props.Ubound
		      Dim prop As Xojo.Introspection.PropertyInfo = props(q)
		      If prop.Name = "Header" Then
		        _setHeader = prop
		        Exit For
		      End If
		    Next
		  End If
		  _setHeader.Value(r) = value
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function PageHeight(extends r as report) As Int64
		  Static _PageHeight As Xojo.Introspection.MethodInfo
		  If _PageHeight = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PageHeight" Then
		        _PageHeight = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _PageHeight.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function PageWidth(extends r as report) As Int64
		  Static _PageWidth As Xojo.Introspection.MethodInfo
		  If _PageWidth = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PageWidth" Then
		        _PageWidth = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _PageWidth.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function PixelsPerInch(extends r as report, flag as Boolean) As Int64
		  Static _PixelsPerInch As Xojo.Introspection.MethodInfo
		  If _PixelsPerInch = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PixelsPerInch" Then
		        _PixelsPerInch = method
		        exit for
		      End If
		    Next
		  End If
		  Dim a() As Auto 
		  a.Append  flag
		  Return _PixelsPerInch.Invoke(r, a)
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub PlaceAllRows(extends r as report)
		  Static _PlaceAllRows As Xojo.Introspection.MethodInfo
		  If _PlaceAllRows = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PlaceAllRows" Then
		        _PlaceAllRows = method
		        Exit For
		      End If
		    Next
		  End If
		  _PlaceAllRows.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub PlaceOneRow(extends r as report)
		  Static _PlaceOneRow As Xojo.Introspection.MethodInfo
		  If _PlaceOneRow = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PlaceOneRow" Then
		        _PlaceOneRow = method
		        Exit For
		      End If
		    Next
		  End If
		  _PlaceOneRow.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub PlacePageFooter(extends r as report)
		  Static _PlacePageFooter As Xojo.Introspection.MethodInfo
		  If _PlacePageFooter = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PlacePageFooter" Then
		        _PlacePageFooter = method
		        Exit For
		      End If
		    Next
		  End If
		  _PlacePageFooter.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub PlacePageHeader(extends r as report)
		  Static _PlacePageHeader As Xojo.Introspection.MethodInfo
		  If _PlacePageHeader = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "PlacePageHeader" Then
		        _PlacePageHeader = method
		        Exit For
		      End If
		    Next
		  End If
		  _PlacePageHeader.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function ReportStarted(extends r as report) As date
		  Static _ReportStarted As Xojo.Introspection.MethodInfo
		  If _ReportStarted = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "ReportStarted" Then
		        _ReportStarted = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _ReportStarted.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub SaveAsXML(extends r as report, f as FolderItem)
		  Static _SaveAsXML As Xojo.Introspection.MethodInfo
		  If _SaveAsXML = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "SaveAsXML" Then
		        _SaveAsXML = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto 
		  a.Append f
		  _SaveAsXML.Invoke(r, a)
		  
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Scale(extends r as report) As Double
		  Static _scale As Xojo.Introspection.MethodInfo
		  If _scale = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "Scale" Then
		        _scale = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _scale.Invoke(r)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Section(extends r as report, SectionName as String) As Reports.RBReportSection
		  Dim ms() As Xojo.Introspection.PropertyInfo = r.Properties
		  For q As Integer = 0 To ms.Ubound
		    Dim m As Xojo.Introspection.PropertyInfo = ms(q)
		    If m.Name = SectionName Then Return m.Value(r)
		  Next
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function SpillPagesIfNeeded(extends r as report, Pages as int64) As Int64
		  Static _SpillPagesIfNeeded As Xojo.Introspection.MethodInfo
		  If _SpillPagesIfNeeded = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "SpillPagesIfNeeded" Then
		        _SpillPagesIfNeeded = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append pages
		  _SpillPagesIfNeeded.Invoke(r, a)
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub StartPage(extends r as report)
		  Static _StartPage As Xojo.Introspection.MethodInfo
		  If _StartPage = Nil Then
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "StartPage" Then
		        _StartPage = method
		        Exit For
		      End If
		    Next
		  End If
		  _StartPage.Invoke(r)
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub SwapSelfAndMe(extends r as report, byref object1 as object, byref object2 as object)
		  Static _SwapSelfAndMe As Xojo.Introspection.MethodInfo
		  If _SwapSelfAndMe = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "SwapSelfAndMe" Then
		        _SwapSelfAndMe = method
		        Exit For
		      End If
		    Next
		  End If
		  Dim a() As Auto
		  a.Append Object1
		  a.Append Object2
		  _SwapSelfAndMe.Invoke(r, a)
		  Object1 = a(0)
		  object2 = a(1)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Units(extends r as report) As Reports.Units
		  Static _Units As Xojo.Introspection.MethodInfo
		  If _Units = Nil Then 
		    Dim methods() As Xojo.Introspection.MethodInfo = r.Methods
		    For q As Integer = 0 To Methods.Ubound
		      Dim method As Xojo.Introspection.MethodInfo = Methods(q)
		      If method.Name = "Units" Then
		        _Units = method
		        Exit For
		      End If
		    Next
		  End If
		  Return _Units.Invoke(r)
		End Function
	#tag EndMethod


	#tag ViewBehavior
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Module
#tag EndModule
